#include <stdio.h>
#include <stdio_ext.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
	#define BUFFER_SIZE 256
	#define ARRAY_LENGTH (int) 4
	#define SEND_THIS_NAME (int) 1
	#define	ENEMY_NAME (int) 2
	#define MY_TURN (int) 3
    #define ENEMY_TURN (int) 4
	#define VICTORY (int) 5
	#define YOU_LOSE  (int) 6
	#define	DRAW (int) 7
	#define I_QUIT (int) 8
    #define ENEMY_QUIT (int) 9
	#define HELLO_MESSAGE (char*) "Can i haz validation?"
    
/*                                  */
/*                                  */
/*	Το πρόγρσμμσ είναι για linux ΛΣ	*/
/*           ~~04/10/2017~~         */
/* version 2.0                      */
/*                                  */
typedef struct sockaddr Sockaddr;
typedef struct sockaddr_in Sock_in;


typedef struct Player
{
	char name[50],enemy[50];
	int choice; /* 00 01 230 33 OXI 44 -1 για ήττα*/ 
} Player;


	/*~~~FUNCTION PROTOTYPES~~~*/
void PrintGameArray();
int GetPlayerChoice();
int validateIP4Dotted(const char *s);
void CTRL_C(int sig);
void serverTimeout(int sig);
int sendMessage(const char* msg, int len);
int receiveMessage(char* msg,int len);
	/*~~~GLOBAL VARIABLES~~~*/
int game_array[ARRAY_LENGTH][ARRAY_LENGTH];
int sock_dis;
volatile int program_flag;/* 0=τίποτα -1=παραιτήθηκα -2=έπεσε η σύνδεση , -1=ήττα, 2=νίκη, 1=ισοπαλία, -3 κάποιο σφάλμα έγινε, 4=ο εχθρός παραιηθηκε*/



/*~~~	MAIN 	~~~*/

/*
    input:   	από την κονολα δυο παράμετροι   
    output:     0 αν εκτελεστεί επιτυχώς αλλίως ένα νούμερο διαφορετικό του μηδενός
    function:   εκτελέι το παιχνίδι μεταξύ δυο παικτών απο διαφορετικούς υπολογιστές
*/
int main(int argc, char* argv[])
{  
	/*char answer;*/
	Sock_in server_info;
	int k,l=0,pchoice;
	Player p;
    char buffer[BUFFER_SIZE],move[2];


    for (int i=0; i<ARRAY_LENGTH; i++)
    {
        for(int j=0; j<ARRAY_LENGTH; j++)
        {
            game_array[i][j]=0;
        }
    }
	if (argc<3)
	{
        printf("Too few parameters.\nUsage is:  %s <server ip> <port>\n",argv[0]);
        exit(1);
    }
	else if (argc>3)
    {
        printf("Error: Too many parameters.\nUsage is:  %s <server ip> <port>\n",argv[0]);
        exit(1);
    }
    if(validateIP4Dotted(argv[1])==0)
    {
        printf("The IP address is not a valid one. Double check it and run this program again.\n");
        exit(1);
    }
    if ((sock_dis = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
    {
        printf("socket creation failed: ");
        exit(EXIT_FAILURE);
    }
    server_info.sin_family=AF_INET;             /* Internet address family */
    server_info.sin_addr.s_addr=inet_addr(argv[1]);    /* Server IP address */
    server_info.sin_port=htons(atoi(argv[2])); /* Server port */

    
    while(l<3)/*η l χρησιμοποιήται ως μετρητής για τις αποτυχίεες σύνδεσης, 3 αποτυχιες -> exit()*/
    {
    	if (connect(sock_dis, (Sockaddr*) &server_info, sizeof(server_info)) < 0)
    	{
        	perror("connect() failed.");
        	l++;
        	if (l==3)
        	{
        		exit(1);
        	}
        	printf("Attempting again...\n");
        	sleep(2);
        	continue;
    	}
    	else
    	{
    		printf("Waiting for validation of server");
    		sendMessage(HELLO_MESSAGE, 21);
    		alarm(10);
    		receiveMessage(buffer,sizeof(buffer));
    		if(buffer[0]=='Y' && buffer[1]=='E' && buffer[2]=='S')
    		{
    			alarm(0);
    			
    		}
    		break;
    	}
	}
	signal(SIGINT,CTRL_C);
	signal(SIGALRM,serverTimeout);

    /*μηδενίζει το πίνακα*/
    for (int i=0; i<ARRAY_LENGTH; i++)
    {
    	for(int j=0; j<ARRAY_LENGTH; j++)
    	{
    		game_array[i][j]=0;
    	}
   	}

   	printf("Welcome to 4 in row game!\nPlease enter your name: ");

    l=0;
    k=-1;
    int tmpvar;
    while(k<1)
    {
        k=strlen(fgets(p.name,sizeof(p.name)-1,stdin));
    	__fpurge(stdin);
       	__fpurge(stdout);
    	if (k<0) 
    	{
        	perror("Error reading name");
        	if(++l==3)
        	{
            	printf("Unable to read your name exiting game\n");
            	exit(6);
        	}
    	}
        l=-1;
    }
    __fpurge(stdin);
    printf("Hello %s\nWaiting for another Player...\n", p.name);
    while (1)
    {
        if (program_flag!=0)
        {
            break;
        }
    	usleep(250);
        receiveMessage(buffer,1);
 		__fpurge(stdin);
        __fpurge(stdout);
        switch(buffer[0]-0x30)
        {
            case SEND_THIS_NAME:/*το ονομά μου*/
                sendMessage(p.name,sizeof(p.enemy));
                break;
            case ENEMY_NAME:/*όνομα εχθρού*/
                tmpvar=receiveMessage(p.enemy,sizeof(p.enemy));
                p.enemy[tmpvar]='\0';
                p.enemy[tmpvar-1]='\0';
                break;
            case MY_TURN:/*η σειρά μου*/
                printf("It's your turn.\n");
                PrintGameArray();
                pchoice=GetPlayerChoice();
                PrintGameArray(); 
                //printf("player chose %d\n",pchoice);
                if (pchoice==-1)
                {
                    program_flag=-1;
                    move[0]=I_QUIT+0x30;
                    sendMessage(move,1);
                }
                else
                {
                    move[0]=(pchoice/10)+0x30;
                    move[1]=(pchoice%10)+0x30;
                    sendMessage(move,sizeof(move));
                }
                break;
            case ENEMY_TURN:/*η σειρά του αντιπάλου*/
                l=receiveMessage(move,sizeof(move));
                
                if (l==1)/*command*/
                {
                   if( move[0]==(0x30+ENEMY_QUIT) )
                    {
                        program_flag=4;
                    }
                    if (move[0]==(0x30+YOU_LOSE))
                    {
                        program_flag=-1;
                    }
                    if (move[0]-0x30==-2)
                    {
                        program_flag=-1;
                        break;
                    }

                }
                else
                {
                    if ( move[0]<'0' || move[0]>'0'+ARRAY_LENGTH || move[1]<'0' || move[1]>'0'+ARRAY_LENGTH )
                    {
                        program_flag=-2;
                        break;
                    }
                    game_array[move[0]-0x30][move[1]-0x30]=2;
                    PrintGameArray();/*                                        */
                }
                break;
            case VICTORY:/*νίκησα*/
                PrintGameArray();
                program_flag=2;
                break;
            case YOU_LOSE:/*ήττα*/
                PrintGameArray();
                program_flag=-1;
                break;
            case DRAW:/*ισοπαλία*/
                program_flag=1;
                break;
            case ENEMY_QUIT:/*παραιτηθηκε ο αντιπαλος*/
                program_flag=4;
                break;
            default:
                break;
        }
    }
    /* 0=τίποτα -1=παραιτήθηκα -2=έπεσε η σύνδεση , -1=ήττα, 2=νίκη, 1=ισοπαλία, -3 κάποιο σφάλμα έγινε, 4=παραιτηθηκε ο αντιπαλος */
    switch(program_flag)
    {
        case -2:
            printf("Connection terminated Unexpectedly\n");
            break;
        case -1:
            PrintGameArray();
            printf("You have lost!\n");
            break;
        case -3:
            printf("You have lost!\n");
            move[0]=I_QUIT+'0';
            sendMessage(move,1);
            break;
        case 1:
            printf("Game is a draw\n");
            break;
        case 2:
            printf("You won!\n");
            break;
        case 4:
            printf("You won against %sHe has quit the game.\n",p.enemy);
            break;
        default:
            printf("An error occured somewhere!\nExiting game\n");
            exit(7);
    }
	printf("Thank you for playing our game!\n");
	close(sock_dis);
	exit(0);
}



/*
    input:      ο πίνκας του παιχνιδιού και το μήκος του ( ν * ν πίνακας)
    output:     -
    function:   τυπώνει το πίνακα του παιχνδίου αλλά με χαρακτήρες ASCII και όχι με αριθμούς
*/
void PrintGameArray()
{
    printf("~~~~~~~~~~~~~~~~~~~~\n  0 1 2 3\n");
	for (int i=0; i<ARRAY_LENGTH; i++)
    {
        printf("%d ",i);
        for (int j=0; j<ARRAY_LENGTH; j++)
        {
            if ( game_array[i][j]==0)
            {
                printf("_ ");
            }
            else if(game_array[i][j]==1)
            {
                printf("X ");
            }
            else
            {
                printf("O ");
            }
        }
        printf("\n");
    }
    printf("~~~~~~~~~~~~~~~~~~~~\n");
}

/*	
	input:		πίνακας του παιχνιδιού και το μέγεθος του πίνακα
	output:		ένας δυψήφιος αριθμός συνδιασμός των 0,1,2,3 ή -1 αν θέλει να παραιτηθεί (χάνει)
	function:	υπολογίζει και ελέγχει αν είναι έγκυρες τιμές.
*/
int GetPlayerChoice()
{
	int x,y;


	printf("Please enter a valid choice (-1 for quit): ");
    while(1)
    {

        do
        {
            
            if (program_flag!=0)
            {
                printf("Interrrupted");
                break;
            }
            printf("Enter column: ");
            while ( (scanf("%d",&x))<0 )
            {
                __fpurge(stdin);
            }
            if (x<0)
            {
                return -1;
            }
        }
        while(x<0 || x>ARRAY_LENGTH);
        do
        {
            
            if (program_flag!=0)
            {
                printf("Interrrupted");
                break;
            }
            printf("Enter line: ");
            while ( (scanf("%d",&y))<0 )
            {
                __fpurge(stdin);
               
            }
            if (y<0)
            {
                return -1;
            }
        }
        while(y<0 || y>ARRAY_LENGTH);
        
        if (game_array[y][x]== 0)
        {
            game_array[y][x]=1;
            break;
        }
        else
        {
            printf("Invalid choice. This box is already used!\n");
        }
    }
    return (y*10+x);
}

/*
    input:      ένα σήμα
    output:     -
    function:   ενημερώνει το game_flag με την κατάλληλ τιμη ώστε να τερματιστεί σωστά το παιχνίδι.
*/
void CTRL_C(int sig)
{
    program_flag=-3;
    write(sock_dis,(void*)I_QUIT+0x30,1);
}



int sendMessage(const char* msg,int len)
{
    int a;

    a=write(sock_dis,msg,len);
    __fpurge(stdout);
    if(a<0)
    {
        perror("Error sending data: ");
        program_flag=-2;
    }
    return a;
}


int receiveMessage(char* msg,int len)
{
    int a;

    a=read(sock_dis,msg,len);
    if(a<0)
    {
        perror("Error receiving data: ");
        program_flag=-2;
    }
    else if (a==0)
    {
        printf("Connection Terminated!\n");
        exit(12);
    }
    else
    {
        msg[a]='\0';
    }
    __fpurge(stdout);
    return a;
}




int validateIP4Dotted(const char *s)
{
    int len = strlen(s);

    if (len < 7 || len > 15)
        return 0;

    char tail[16];
    tail[0] = 0;

    unsigned int d[4];
    int c = sscanf(s, "%3u.%3u.%3u.%3u%s", &d[0], &d[1], &d[2], &d[3], tail);

    if (c != 4 || tail[0])
        return 0;

    for (int i = 0; i < 4; i++)
        if (d[i] > 255)
            return 0;

    return 1;
}



/*
	if programm gets SIGALARM from timeout
*/
void serverTimeout(int sig)
{
	printf("timedout...\nExiting");
	exit(10);
}