// version 2.0

#define _GNU_SOURCE
#include <stdio.h>
#include <errno.h>
#include <stdio_ext.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <string.h>
#include <arpa/inet.h>
#include <ifaddrs.h>
#include <signal.h>
#include <time.h>

#define MAX_GAMES 1
#define NET_BUFFER 256
#define RW_BUFFER 256



int socket_descriptor;
struct sigaction old_action; // for signal catching

struct Connections {
	int descriptor;
	struct sockaddr_in socket;
} ConnectedPlayer[MAX_GAMES*2];

struct Games {
	int GameTable[4][4];
	int rw_socket_p1,rw_socket_p2;
	char p1_name[50],p2_name[50];
	struct sockaddr_in p1_sock,p2_sock;
	int isAvailable;
	int whoWon;
} Game[MAX_GAMES];






void CloseSequence( int );
void PrintGameArray();
void ipInfo();
int isWon(int array[][4], int ,const int );
int StartGame(struct Games* );
int PrepareServer(struct sockaddr_in name,int port);
void GameManager(int);



int main(int argc, char *argv[])
{
	int isFirstTimeRun=1;
	// signal handler //
	struct sigaction action;
		memset(&action, 0, sizeof(action));
		action.sa_handler = & CloseSequence;
	sigaction(SIGINT, &action, &old_action);
	//			//
	struct sockaddr_in server;
	int port;

			system("clear");
		printf("		Four-In-A-Row Server\n\n");
		ipInfo();
		if ( argc==1 ) {
			printf("\nPlease specify the port you want the server to use.\n");
			printf("The port number must be between 1025 and 65535.\n> ");
			while ( !(scanf(" %d",&port))  || ( port < 1025 || port > 65535 )  ) {
				__fpurge(stdin);
				printf("Invalid character. Please input a positive integer.\n");
			}
		}
		else
		{
			port=atol(argv[1]);
		}
		socket_descriptor=PrepareServer(server,port);
		printf("\nClients must connect to port %d\nLet the games begin!\n",port);


	while(1)
	{
		if (isFirstTimeRun==0)
		{
			system("clear");
			printf("		Four-In-A-Row Server\n\n");
			ipInfo();
			printf("\nClients must connect to port %d\nLet the games begin!\n",port);
		}

		 // PREPARE THE NETWORKING PART
			GameManager(socket_descriptor); // HANDLES ALL INCOMMING CONNECTIONS. WILL BE A SEPARATE THREAD
			printf("SERVER CLOSING IN");
				for (int ct=5;ct>=0;ct--)
			{
				printf(" %d",ct);
				sleep(1);
			}
			printf("\n");
		isFirstTimeRun=0;
	}


	close(socket_descriptor);

	return 0;
}


void CloseSequence(int sig)
{
	printf("CloseSequence\n");
	close(Game[0].rw_socket_p1);
	usleep(500);
	close(Game[0].rw_socket_p2);
	usleep(500);
	close(socket_descriptor);
	usleep(500);
	exit(EXIT_SUCCESS);

}


void PrintGameArray()
{
printf("~~~~~~~~~~~~~~~~~~~~\n");
	for (int i=0; i<4; i++)
	{
		for (int j=0; j<4; j++)
	{
		printf("%d ",Game[0].GameTable[i][j]);

	}
		printf("\n");
	}

}







void ipInfo()
{
	struct ifaddrs *ifaddr, *ifa;
	int family, s, n;
	char host[NI_MAXHOST];
	if (getifaddrs(&ifaddr) == -1) {
		perror("getifaddrs");
		exit(EXIT_FAILURE);
	}

	/* Walk through linked list, maintaining head pointer so we
	can free list later */

	printf("\nConnect to one of these addresses:\n\n");

	for (ifa = ifaddr, n = 0; ifa != NULL; ifa = ifa->ifa_next, n++) {
		if (ifa->ifa_addr == NULL)
			continue;
		family = ifa->ifa_addr->sa_family;
		/* Display interface name and family (including symbolic
		form of the latter for the common families) */
		if (family == AF_INET && ( (strcmp(ifa->ifa_name,"lo") != 0) || (strcmp(ifa->ifa_name,"lo0vboxnet0") != 0) ))
			printf("\t%s", ifa->ifa_name);

			/* For an AF_INET* interface address, display the address */
		if (family == AF_INET) {
			s = getnameinfo(ifa->ifa_addr,(family == AF_INET) ? sizeof(struct sockaddr_in) :
					sizeof(struct sockaddr_in6), host, NI_MAXHOST,NULL, 0, NI_NUMERICHOST);
			if (s != 0) {
				printf("getnameinfo() failed: %s\n", gai_strerror(s));
				exit(EXIT_FAILURE);
			}
			printf(" address: %s\n", host);
		}
	}
	freeifaddrs(ifaddr);
}







int isWon(/*struct Games game*/ int g_array[][4], int x,const int y)
{
	/*
	 0 	-> tipota
	 1	->nikise
	Η ΣΥΝΑΡΤΗΣΗ ΕΠΙΣΤΡΦΕΙ 0 ΑΝ ΔΕΝ ΝΙΚΗΣΕ ΚΑΙ 1 ΑΝ ΝΙΚΗΣΕ
	ΔΕΝ ΧΡΕΙΑΖΕΤΑΙ ΝΑ ΥΠΟΛΟΓΙΣΤΕΙ Η ΙΣΟΠΑΛΙΑ ΓΙΑΤΙ ΜΕΤΑ ΑΠΟ ΟΡΙΣΜΕΝΕΣ ΚΙΝΗΣΕΙς ΑΝ ΔΕΝ ΕΧΕΙ ΝΙΚΗΣΕΙ ΚΑΝΕΙΣ ΤΟΤΕ ΕΙΝΑΙ ΙΣΟΠΑΛΙΑ
	ΓΙΑ ΝΑ ΔΕΙΣ (ΧΩΡΙΣ ΝΑ ΑΛΛΑΞΕΙΣ ΤΟΝ ΥΠΑΡΧΩΝ ΚΩΔΙΚΑ) ΘΑ ΕΛΕΓΧΕΙΣ ΑΝ ΕΙΝΑ 1 ΚΑΙ ΤΟΤΕ ΑΥΤΟ ΘΑ ΣΗΜΑΙΝΕΙ ΠΩΣ ΑΥΤΟΣ ΠΟΥ ΕΚΑΝΕ ΤΕΛΕΥΤΑΙΟΣ ΚΙΝΗΣΗ ΕΧΕΙ ΝΙΚΗΣΕΙ
	ΔΗΛΑΔΗ ΑΝ ΠΑΙΖΕΙ Ο (1) ΚΑΙ ΝΙΚΗΣΕ ΤΟΤΕ ΑΠΛΩΣ ΣΤΕΛΝΕΙΣ ΟΤΙ ΝΙΚΗΣΕ Ο (1) ΚΑΙ ΣΤΟΥΣ 2
	ΜΕΤΑ ΑΠΟ ΚΑΘΕ ΕΠΙΛΟΓΗ ΤΩΝ ΠΑΙΚΤΩΝ ΚΑΝΕΙΣ ΕΛΕΓΧΟ ΝΑ ΔΕΙΣ ΑΝ ΕΧΕΙ ΝΙΚΗΣΕΙ
	ΓΙΑ ΤΗΝ ΙΣΟΠΑΛΙΑ ΘΑ ΕΧΕΙΣ ΕΝΑ ΜΕΤΡΗΤΗ ΠΟΥ ΜΕΤΑ ΠΟΣΕΣ ΕΛΕΥΘΕΡΕΣ ΘΕΣΕΙΣ ΥΠΑΡΧΟΥΝ ΣΤΟ ΠΙΝΑΚΑ (ΑΡΧΗΖΕΙ ΑΠΟ MAX(=4*4=16) ΚΑΙ ΜΕ ΚΑΘΕ ΚΙΝΗΣΗ ΘΑ ΜΕΙΩΝΕΤΑΙ ΚΑΤΑ 1)
	ΟΤΑΝ ΦΤΑΣΕΙ ΣΤΟ 0 ΚΑΙ ΔΕΝ ΕΧΕΙ ΝΙΚΗΣΕΙ ΚΑΝΕΙΣ (ΕΧΟΥΝ ΠΑΙΞΕΙ ΚΑΙ ΟΙ ΔΥΟ) ΤΟΤΕ ΘΑ ΤΟΥΣ ΣΤΕΛΕΝΕΙΣ ΤΗΝ ΙΣΟΠΑΛΙ
	**ΠΡΟΣΟΧΗ** ΠΡΕΠΕΙ ΝΑ ΕΛΕΓΞΕΙΣ ΤΙ ΓΙΝΕΤΑΙ ΣΤΑ ΑΚΡΑ ΤΟΥ ΠΑΙΧΝΙΔΙΟΥ (ΔΗΛΑΔΗ ΣΕ ΕΙΔΙΚΕΣ ΠΕΡΙΠΤΩΣΕΙΣ ΠΑΙΖΕΙ Ο ΤΕΛΕΥΤΑΙΟΣ ΝΙΚΑ ΤΙ ΘΑ ΣΤΕΙΛΕΙΣ ( ΜΗ ΣΤΕΙΛΕΙΣ ΣΤΟΝ ΑΛΛΟ ΝΑ ΠΑΙΞΕΙ ΚΑΙ ΜΕΤΑ ΚΑΠΑΚΙ ΙΣΟΠΑΛΙΑ))
	
	*/
	int counter;
	for(int i=0;i<4; i++)/*για γραμμή*/
	{
		if (g_array[x][i]==g_array[x][y])
			counter++;
		else
		{
			counter=0;
			break;
		}
	}
	if (counter==4)
		return 1;

	for(int i=0;i<4; i++)/*για στήλη*/
	{
		if (g_array[i][y]==g_array[x][y])
			counter++;
		else
		{
			counter=0;
			break;
		}
	}
	if (counter==4)
		return 1;

	if (x==0 || x==3)/*για την κύρια διαγώνιο*/
		for(int i=0; i<4; i++)
		{
			if (g_array[i][i]==g_array[x][y])
				counter++;
			else
			{
				counter=0;
				break;
			}
		}
	if (counter==4)
		return 1;

	if ((y==0 || y==3) && (y+x)==3 )
		for (int i=0; i<4; i++)
		{
			if (g_array[i][3-i]==g_array[x][y])
				counter++;
			else
			{
				counter=0;
				break;
			}
		}
	if (counter==4) return 1;
		return 0;
}


int StartGame(struct Games* game) // EDW THA PEXTEI TO PAIXNIDI
{
	/*
			LIST OF MESSAGE FLAGS
THESE ARE SENT TO THE CLIENT , WHO IN TURN RESPONDS WHITH A MESSAGE THAT STARTS WITH THE APROPRIATE FLAG


		1 : THE SERVER READS THE PLAYERS NAME
		2 : THE SERVER SENDS THE ENEMY'S NAME
		3 : INFORM A PLAYER THAT IT IS THEIR TURN
		4 : INFORN A PLAYER THAT IT IS NOT THEIR TURN
		5 : INFORM A PLAYER THAT THEY WON
		6 : INFORM A PLAYER THAT THEY LOST
		7 : INFORM A PLAYER THAT IT WAS A DRAW
		8 : IF THE SERVER RECEIVES THIS , IT MEANS THE PLAYER HAS QUIT
		9 : INFORM A PLAYER THAT THE OTHER HAS QUIT


	*/

	char messagebuffer[RW_BUFFER];
	int turn=time(NULL)%2;
	int rcvd_bytes;
	for(int i=0;i<RW_BUFFER;i++)
		messagebuffer[i]='\0';
	printf("Reading player 1's name\n");


	/* READ PLAYER 1 NAME */

	if (write( game->rw_socket_p1, "1", 1) == -1) {

		perror("Error writing to rw_socket_p1");
		return -3;
	}

	rcvd_bytes=read(game->rw_socket_p1, messagebuffer, RW_BUFFER );
	if (rcvd_bytes <=0)
	{
		printf("Error reading from rw_socket_p1\n");
		return -3;
	}
	strncpy(game->p1_name,messagebuffer,rcvd_bytes);
	printf("Player1 name : %s",messagebuffer);
	
	/* READ PLAYER 2 NAME */

	if  ( write( game->rw_socket_p2, "1", 1) == -1 )
	{
		perror("Error writing to rw_socket_p2");
	}
	rcvd_bytes=read( game->rw_socket_p2, messagebuffer, RW_BUFFER);
	if (rcvd_bytes <=0)
	{
		printf("Error reading from rw_socket_p2\n");
		return -3;
	}

	strncpy(game->p2_name,messagebuffer,rcvd_bytes);
	printf("Player2 name : %s",messagebuffer);

	/* SEND ENEMY NAME TO PLAYER 1  */

	if ( write( game->rw_socket_p1, "2", 1) == -1 )
	{
		perror("Error writing to rw_socket_p1");
		return -3;
	}
	if ( write( game->rw_socket_p1, game->p2_name, sizeof(game->p2_name)  ) == -1)
	{
		perror("Error writing to rw_socket_p1");
		return -3;
	}

	/* SEND ENEMY NAME TO PLAYER 2  */

	if (write( game->rw_socket_p2, "2", 1) == -1 )
	{
		perror("Error writing to rw_socket_p2");
		return -3;
	}
	if (write( game->rw_socket_p2, game->p1_name, sizeof(game->p1_name)  ) == -1)
	{
		perror("Error writing to rw_socket_p2");
		return -3;
	}


	char move[3];
	move[2]='\0';
	int available_moves=16;
	while (available_moves>0)
	{
		/* INFORM PLAYERS OF THEIR TURNS */

		switch ( turn ) {

			case 1 :

				if (write( game->rw_socket_p1, "3", 1) == -1)
				{
					perror("Error writing to rw_socket_p1");
					return -3;
				}

				if (write( game->rw_socket_p2, "4", 1) == -1)
				{
					perror("Error writing to rw_socket_p2");
					return -3;
				}

				break;

			case 0 :

				if (write( game->rw_socket_p2, "3", 1) == -1)
				{
					perror("Error writing to rw_socket_p2");
					return -3;
				}

				if (write( game->rw_socket_p1, "4", 1) == -1)
				{
					perror("Error writing to rw_socket_p1");
					return -3;
				}

				break;
		}






		if ( turn == 1 ) // tote einai i seira toy p1
		{
			if (read(game->rw_socket_p1,move,sizeof(move)) <=0) //12
			{
				printf("Error reading from rw_socket_p1\n");
				printf("Player 1 has disconnected.\n");
				printf("Player 2 has won the game.\n");
				if (move[0]-0x30 < 0 || move[0]-0x30 > 8 )
				{
					printf("SERVER RECEIVER INVALID COMMAND.\n RESETTING...\n");
					return -3;
				}
				if (write(game->rw_socket_p2,"9",1) == -1)
				{
					perror("Error writing to rw_socket_p2");
				}
				return -3;

			}

			game->GameTable[move[0]-0x30][move[1]-0x30]=1;
			move[2]='\0';


			if ( (move[0] - 0x30 == 8 ) || (move[1] - 0x30 == 8 ) ) {
				printf("Player 1 has quit the game.\n");
				printf("Player 2 has won the game.\n");	
				if (write(game->rw_socket_p2,"9",1) == -1)
				{
					perror("Error writing to rw_socket_p2");
				}

				return 0;
			}
			available_moves--;
			printf("Player 1 chose %s (y,x)\n",move);

			if(isWon(game->GameTable,move[0]-0x30,move[1]-0x30) == 1)
			{
				printf("Player 1 has won the game\n");
				if (write(game->rw_socket_p1,"5",1) == -1)
				{
					perror("Error writing to rw_socket_p1");
				}

				if (write(game->rw_socket_p2,"6",1) == -1)
				{
					perror("Error writing to rw_socket_p2");
				}

				break;
			}

			if (write(game->rw_socket_p2,move,sizeof(move)) == -1)
			{
				perror("Error writing to rw_socket_p2");
			}


		}

		else
		{

			if (read(game->rw_socket_p2,move,sizeof(move)) <=0)
			{
				printf("Error reading from rw_socket_p2\n");
				printf("Player 2 has disconnected.\n");
				printf("Player 1 has won the game.\n");
				if (move[0]-0x30 < 0 || move[0]-0x30 > 8 )
				{
					printf("SERVER RECEIVER INVALID COMMAND.\nRECEIVED %s FROM rw_socket_p2",move);
				}
				if (write(game->rw_socket_p1,"9",1) == -1)
				{
					perror("Error writing to rw_socket_p2");
				}
				return -3;
			}
			game->GameTable[move[0]-0x30][move[1]-0x30]=1;
			move[2]='\0';




			if ( (move[0] - 0x30 == 8 ) || (move[1] - 0x30 == 8 ) ) {
				printf("Player 2 has quit the game.\n");
				printf("Player 1 has won the game.\n");	
				if (write(game->rw_socket_p1,"9",1) == -1)
				{
					perror("Error writing torw_socket_p1");
				}

				return 0;
			}
			available_moves--;
			printf("Player 2 chose %s (y,x)\n",move);

			if(isWon(game->GameTable,move[0]-0x30,move[1]-0x30) == 2)
			{
				printf("Player 2 has won the game\n");
				if (write(game->rw_socket_p2,"5",1) == -1)
				{
					perror("Error writing to rw_socket_p2");

				}

				if (write(game->rw_socket_p1,"6",1) == -1)
				{
					perror("Error writing to rw_socket_p1");
				}

				break;
			}

			if (write(game->rw_socket_p1,move,sizeof(move)) == -1)
			{
				perror("Error writing to rw_socket_p1");
			}


		}
		turn=1-turn; // flips a 0 to 1 and vice-versa

		PrintGameArray();

		if (available_moves==0) // GAME HAS RESULTED IN A TIE
		{
			if (write(game->rw_socket_p1,"7",1) == -1)
			{
				perror("Error writing to rw_socket_p1");
			}
			if (write(game->rw_socket_p2,"7",1) == -1)
			{
				perror("Error writing to rw_socket_p2");
			}
		}
	}
	return 0;
}




int PrepareServer(struct sockaddr_in name,int port) //PREPARES SERVER TO ACCEPT CONNECTIONS
{
	/*

	PREPARES THE NETWORKING PART OF THE SERVER
	PLUS IT INITIALIZES THE STRUCTS


	*/
	int socket_descriptor;


	for (int i=0;i<MAX_GAMES*2;i++) {
		for (int j=0;i<4;i++) {
			for (int k=0;j<4;j++) {
				Game[i].GameTable[j][k]=0;
			}
		}
		strcpy(Game[i].p1_name,"");
		strcpy(Game[i].p1_name,"");
		ConnectedPlayer[i].descriptor=0;
		ConnectedPlayer[i + MAX_GAMES].descriptor=0;
		Game[i].whoWon=0;
	}




	//SOCKET()
	socket_descriptor = socket(AF_INET,SOCK_STREAM,0);
	if ( socket_descriptor == -1) {
		perror("Error Creating Socket");
		exit(EXIT_FAILURE);
	}

	//CREATING THE STRUCT
	name.sin_family=AF_INET;
	name.sin_addr.s_addr=htons(INADDR_ANY);
	name.sin_port=htons(port);

	//BIND()
	if ( bind(socket_descriptor,(struct sockaddr *) &name,sizeof(name)) == -1 ) {
		perror("Error Binding");
		exit(EXIT_FAILURE);
	}
	//LISTEN()
	if  ( listen(socket_descriptor, NET_BUFFER) == -1 ) {
		perror("Error Listening");
		exit(EXIT_FAILURE);
	}
	//printf("IP address is: %s\n", inet_ntoa(name.sin_addr));
	return socket_descriptor;
}

void GameManager(int socket_descriptor)
{
	socklen_t peer_size=sizeof(struct sockaddr_in);
	int rcvd_bytes;
	char messagebuffer[RW_BUFFER];
	printf("Waiting For Player 1...\n");
	if ((Game[0].rw_socket_p1 = accept(socket_descriptor, (struct sockaddr *) &Game[0].p1_sock,&peer_size)) == -1 ) {
			perror("Error Accepting");
			exit(EXIT_FAILURE);
	}

	else {
		printf("Player 1 Connected!\n");
		rcvd_bytes=read(Game[0].rw_socket_p1, messagebuffer, RW_BUFFER );
		if (rcvd_bytes <=0)
		{
			printf("Error reading from rw_socket_p1\n");
		}
		else 
		{
			messagebuffer[21]='\0';
			//printf("Received %d bytes ' %s ' from player 1",rcvd_bytes,messagebuffer);
			if( strncmp(messagebuffer,"Can i haz validation?",sizeof("Can i haz validation?")) == 0)
			{
				write(Game[0].rw_socket_p1,"YES",3);
			}
			else
			{
				printf("Invalid message from rw_socket_p1. Restarting server\n");
				sleep(5);
				return;
			}
		}
		
	}



	printf("Waiting For Player 2...\n");
	if ((Game[0].rw_socket_p2 = accept(socket_descriptor, (struct sockaddr *) &Game[1].p2_sock,&peer_size)) == -1 ) {
			perror("Error Accepting");
			exit(EXIT_FAILURE);
	}
	else {
		printf("Player 2 Connected!\n");
		rcvd_bytes=read(Game[0].rw_socket_p2, messagebuffer, RW_BUFFER );
		if (rcvd_bytes <=0)
		{
			printf("Error reading from rw_socket_p1\n");
		}
		else 
		{
			messagebuffer[21]='\0';
			//printf("Received %d bytes ' %s ' from player 1\n",rcvd_bytes,messagebuffer);
			if( strncmp(messagebuffer,"Can i haz validation?",sizeof("Can i haz validation?")) == 0)
			{
				write(Game[0].rw_socket_p2,"YES",3);
			}
			else
			{
				printf("Invalid message from rw_socket_p2.\n Restarting server");
				sleep(5);
				return;
			}
		}
		
	}
	StartGame(Game+0);

	close((Game+0)->rw_socket_p1);
	close((Game+0)->rw_socket_p2);


}